diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
index 8cf74de5f..0f5b492d5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenStats.java
@@ -108,7 +108,7 @@ public class ScreenStats extends Screen {
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         Lighting.enableInventoryLight();
         Item item = Item.itemsList[itemID];
-        ItemModelDispatcher.getInstance().getDispatch(item).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, item.getDefaultStack(), x + 2, y + 2, 1F);
+        ItemModelDispatcher.getInstance().getDispatch(item).renderGui(Tessellator.instance, null, item.getDefaultStack(), x + 2, y + 2, 1f, 1f, 1f);
         Lighting.disable();
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
@@ -285,7 +285,7 @@ public class ScreenStats extends Screen {
                 return;
             }
             Item item = statItem.getItem();
-            String s = I18n.getInstance().translateNameKey(item.getKey()).trim();
+            String s = I18n.getInstance().translateKey(item.getKey() + ".name").trim();
             tooltip.render(s, x, y, 8, -8);
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index 0ad9d515d..2a1331a24 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -835,8 +835,8 @@ public class ScreenAchievements extends Screen
 
             GL11.glTranslated(achViewX + 3 * zoom, achViewY + 3 * zoom, 0);
             GL11.glScaled(zoom, zoom, 1);
-            ItemModelDispatcher.getInstance().getDispatch(achievementItem)
-                .renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, achievementItem.getDefaultStack(), 0, 0, 1.0f);
+//            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, achievementItem.getDefaultStack(), 0, 0, 1.0f);
+            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderGui(Tessellator.instance, null, achievementItem.getDefaultStack(), 0, 0, 1f, 1.0f, 1f);
 
             GL11.glDisable(GL11.GL_LIGHTING);
             GL11.glPopMatrix();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
index e2170d571..b923dcbc3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPage.java
@@ -75,7 +75,7 @@ public abstract class AchievementPage {
     public abstract int lineColorCanUnlock(boolean isHovered);
 
     public static IconCoordinate getTextureFromBlock(Block<?> block) {
-        return BlockModelDispatcher.getInstance().getDispatch(block).getBlockTextureFromSideAndMetadata(Side.TOP, 0);
+        return BlockModelDispatcher.getInstance().getDispatch(block).getOverlayTexture(0);
     }
 
     public static class AchievementEntry {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
index a0c821058..264f94275 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
@@ -28,12 +28,12 @@ public class AchievementPageNether extends AchievementPage {
 
     @Override
     public @NotNull String getName() {
-        return I18n.getInstance().translateNameKey(key);
+        return I18n.getInstance().translateKey(key + ".name");
     }
 
     @Override
     public @NotNull String getDescription() {
-        return I18n.getInstance().translateDescKey(key);
+        return I18n.getInstance().translateKey(key + ".desc");
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
index d258e97d0..8ab77a790 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
@@ -33,12 +33,12 @@ public class AchievementPageOverworld extends AchievementPage {
 
     @Override
     public @NotNull String getName() {
-        return I18n.getInstance().translateNameKey(key);
+        return I18n.getInstance().translateKey(key + ".name");
     }
 
     @Override
     public @NotNull String getDescription() {
-        return I18n.getInstance().translateDescKey(key);
+        return I18n.getInstance().translateKey(key + ".desc");
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index 168366009..134d3721e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -563,7 +563,8 @@ public class ScreenGuidebook
                 GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
                 GL11.glEnable(GL11.GL_DEPTH_TEST);
-                ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, fr, re, icon, x + iconOffset + xo, y + 4, 1.0f);
+//                ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, fr, re, icon, x + iconOffset + xo, y + 4, 1.0f);
+                ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(Tessellator.instance, null, icon, x + iconOffset + xo, y + 4, 1.0f, 1f, 1f);
                 GL11.glDisable(GL11.GL_DEPTH_TEST);
 
                 GL11.glDisable(GL12.GL_RESCALE_NORMAL);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 3091bc47e..7b6cbe466 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -120,7 +120,7 @@ public class HudIngame extends Gui
         }
 
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
-            if (component.isVisible(mc)) {
+            if (component.isVisible(mc) && component.isEnabled(mc)) {
                 component.render(mc, this, width - sp * 2, height - sp * 2, partialTicks);
             }
         }
@@ -306,7 +306,7 @@ public class HudIngame extends Gui
                 debugOffset += space;
 
                 drawDebugScreenLine("Entities: " + mc.currentWorld.getLoadedEntityList().size());
-                drawDebugScreenLine("Block Entities: " + mc.currentWorld.getLoadedBlockEntityList().size());
+                drawDebugScreenLine("Tile Entities: " + mc.currentWorld.getLoadedTileEntityList().size());
 
                 debugOffset += space;
 
@@ -326,7 +326,7 @@ public class HudIngame extends Gui
                     Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
                     String seasonString = season != null ? season.getTranslatedName() : "None";
                     Weather weather = mc.currentWorld.getCurrentWeather();
-                    String weatherString = weather != null ? weather.getTranslatedName() : "None";
+                    String weatherString = weather != null ? stringtranslate.translateKey(weather.getNameLanguageKey()) : "None";
                     
                     int blockX = MathHelper.floor(mc.thePlayer.x);
 					int blockY = MathHelper.floor(mc.thePlayer.y);
@@ -498,7 +498,7 @@ public class HudIngame extends Gui
                         Weather weather = mc.currentWorld.getCurrentWeather();
                         if (weather != null && weather != mc.currentWorld.worldType.getDefaultWeather())
                         {
-                            this.drawString(font, weather.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
+                            this.drawString(font, stringtranslate.translateKey(weather.getNameLanguageKey()), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
                         }
                     }
 					if(mc.gameSettings.overlayShowBiome.value)
@@ -523,7 +523,8 @@ public class HudIngame extends Gui
                 {
                     int x = 2 + sp;
                     int y = height - sp - 64 + i * 16;
-                    ItemModelDispatcher.getInstance().getDispatch(stack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, stack, x, y, 1.0f);
+//                    ItemModelDispatcher.getInstance().getDispatch(stack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, stack, x, y, 1.0f);
+                    ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(Tessellator.instance, null, stack, x, y, 1f, 1.0f, partialTicks);
 
                     if (stack.isItemStackDamageable())
                     {
@@ -589,7 +590,8 @@ public class HudIngame extends Gui
                     GL11.glDisable(3042 /* GL_BLEND */);
                     GL11.glEnable(32826 /* GL_RESCALE_NORMAL_EXT */);
                     Lighting.enableInventoryLight();
-                    ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, heldItemStack, x, y, 1.0f);
+//                    ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, heldItemStack, x, y, 1.0f);
+                    ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(Tessellator.instance, null, heldItemStack, x, y, 1f, 1f, partialTicks);
                     Lighting.disable();
                 }
             }
@@ -946,7 +948,7 @@ public class HudIngame extends Gui
         GL11.glDepthMask(false);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, intensity);
-        IconCoordinate portal = BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(mc.thePlayer.portalID)).getBlockTextureFromSideAndMetadata(Side.NORTH, mc.thePlayer.portalColor.blockMeta << 4 | BlockLogicPortal.MASK_COLOR_SET);
+        IconCoordinate portal = BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(mc.thePlayer.portalID)).getOverlayTexture(mc.thePlayer.portalColor.blockMeta << 4 | BlockLogicPortal.MASK_COLOR_SET);
         portal.parentAtlas.bind();
         float f1 = (float) portal.getIconUMin();
         float f2 = (float) portal.getIconVMin();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 4a0cedc82..30175d64b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -182,17 +182,19 @@ public class HudComponentHotbar
             GL11.glScalef(1.0F / f2, (f2 + 1.0F) / 2.0F, 1.0F);
             GL11.glTranslatef(-(x + 8), -(y + 12), 0.0F);
         }
-        itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemstack, x, y, 1.0f);
+//        itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemstack, x, y, 1.0f);
+        itemModel.renderGui(Tessellator.instance, null, itemstack, x, y, 1, 1, partialTick);
         if (animProgress > 0.0F)
         {
             GL11.glPopMatrix();
         }
-        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemstack, x, y, 1.0f);
+        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemstack, x, y, null, 1.0f);
     }
 
     private void renderItem(Minecraft mc, ItemStack itemStack, int x, int y) {
         ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-        itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, 1.0f);
-        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, 1.0f);
+//        itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, 1.0f);
+        itemModel.renderGui(Tessellator.instance, null, itemStack, x, y, 1.0f, 1f, 1f);
+        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, null, 1.0f);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 5190d4e47..2627145ab 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -15,7 +15,7 @@ import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
 import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.data.OptionsPages;
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
 import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
@@ -381,7 +381,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
 
         scroll(Mouse.getDWheel());
 
-        BlockEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
+        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
 
         drawStringCentered(font, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index 7c7554931..279dafee4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -49,7 +49,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         Block<?> displayBlock = Blocks.getBlock(DisplayChunk.displayBlockId);
         String name = "None";
         if (displayBlock != null){
-            name = I18n.getInstance().translateNameKey(displayBlock.getKey());
+            name = I18n.getInstance().translateKey(displayBlock.getKey() + ".name");
             ItemStack[] nameStack = displayBlock.getBreakResult(mc.currentWorld, EnumDropCause.PICK_BLOCK, DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ, DisplayChunk.displayBlockMeta, DisplayChunk.displayTileEntity);
             if (nameStack != null && nameStack.length > 0){
                 name = nameStack[0].getDisplayName();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java
index b5c644bc2..a2276c73c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java
@@ -4,7 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
@@ -12,22 +12,22 @@ import org.lwjgl.input.Keyboard;
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityEntryMinecart extends EntityEntry<MinecartEntity>{
+public class EntityEntryMinecart extends EntityEntry<EntityMinecart>{
     @Override
-    public void onTick(MinecartEntity entity) {
+    public void onTick(EntityMinecart entity) {
 
     }
 
     @Override
-    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, MinecartEntity minecart) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, EntityMinecart minecart) {
         ListenerButtonElement button = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKey("model.category.entity.minecart.button.cycle"));
-        button.setActionListener(() -> minecart.type = (minecart.type + 3 + (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1)) % 3);
+        button.setActionListener(() -> minecart.setType((byte) ((minecart.getType() + 3 + (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1)) % 3)));
         return new ArrayList<ButtonElement>(){{add(button);}};
     }
 
     @Override
-    public MinecartEntity getEntityInstance(Minecraft mc, World world) {
-        MinecartEntity minecart = new MinecartEntity(world);
+    public EntityMinecart getEntityInstance(Minecraft mc, World world) {
+        EntityMinecart minecart = new EntityMinecart(world);
         minecart.yRot = 270;
         return minecart;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryWolf.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryWolf.java
index a9b3379a2..d26370f1d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryWolf.java
@@ -67,7 +67,7 @@ public class EntityEntryWolf extends EntityEntry<MobWolf>{
             entityWolf.getEntityData().set(19, material == null ? "" : material.identifier.toString());
         });
 
-        entityWolf.setWolfHeldItem(null);
+        entityWolf.setHeldItem(null);
         ListenerButtonElement hasItem = new ListenerButtonElement(-1, - 120, armor.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.item", false));
 
         TextCycleElement<Integer> itemIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, hasItem.yPosition + 21, 120, 20, 1) {
@@ -82,8 +82,8 @@ public class EntityEntryWolf extends EntityEntry<MobWolf>{
                     int id = Integer.parseInt(s);
                     if (Item.itemsList[id] != null) return id;
                 } catch (Exception ignored){}
-                if (entityWolf.getWolfHeldItem() != null){
-                    return entityWolf.getWolfHeldItem().itemID;
+                if (entityWolf.getHeldItem() != null){
+                    return entityWolf.getHeldItem().itemID;
                 }
                 return 0;
             }
@@ -109,8 +109,8 @@ public class EntityEntryWolf extends EntityEntry<MobWolf>{
                     int id = Integer.parseInt(s);
                     return MathHelper.clamp(id, 0, 0x3FFF);
                 } catch (Exception ignored){}
-                if (entityWolf.getWolfHeldItem() != null){
-                    return entityWolf.getWolfHeldItem().getMetadata();
+                if (entityWolf.getHeldItem() != null){
+                    return entityWolf.getHeldItem().getMetadata();
                 }
                 return 0;
             }
@@ -124,16 +124,16 @@ public class EntityEntryWolf extends EntityEntry<MobWolf>{
         metaCycle.textField.setPrefaceText("Meta: ");
         metaCycle.textField.setPlaceholder("Meta");
 
-        itemIdCycle.setOnValueChanged(() -> entityWolf.setWolfHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement())));
-        metaCycle.setOnValueChanged(() -> entityWolf.setWolfHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement())));
+        itemIdCycle.setOnValueChanged(() -> entityWolf.setHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement())));
+        metaCycle.setOnValueChanged(() -> entityWolf.setHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement())));
         hasItem.setActionListener(() -> {
-            boolean _hasItem = entityWolf.getWolfHeldItem() != null;
+            boolean _hasItem = entityWolf.getHeldItem() != null;
             if (_hasItem){
-                entityWolf.setWolfHeldItem(null);
+                entityWolf.setHeldItem(null);
                 itemIdCycle.enabled = false;
                 metaCycle.enabled = false;
             } else {
-                entityWolf.setWolfHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement()));
+                entityWolf.setHeldItem(new ItemStack(itemIdCycle.getCurrentElement(), 1, metaCycle.getCurrentElement()));
                 itemIdCycle.enabled = true;
                 metaCycle.enabled = true;
             }
@@ -153,7 +153,7 @@ public class EntityEntryWolf extends EntityEntry<MobWolf>{
     @Override
     public MobWolf getEntityInstance(Minecraft mc, World world) {
         MobWolf wolf = new MobWolf(world);
-        wolf.setWolfHeldItem(null);
+        wolf.setHeldItem(null);
         return wolf;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index 17177c34f..caeac86ae 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -65,7 +65,7 @@ public class LanguagePackListComponent
             if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= 3 + i * (BUTTON_HEIGHT + 3) && relativeMouseY <= 3 + i * (BUTTON_HEIGHT + 3) + BUTTON_HEIGHT) {
                 String lang = button.languagePack.getId();
                 mc.gameSettings.language.set(lang);
-                I18n.getInstance().reload(lang, true);
+                I18n.getInstance().reload(lang);
                 mc.currentScreen.init();
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 130580447..4472d7644 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -60,6 +60,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.autoHit))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.easyBridge))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.viewBobbing))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerLeftHanded))
             )
             .withComponent(new OptionsCategory("gui.options.page.general.category.user_interface")
                 .withComponent(new ShortcutComponent("gui.options.page.general.button.edit_hud", () -> mc.displayScreen(new ScreenHudDesigner(mc.currentScreen))))
@@ -75,6 +76,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.heldItemTooltips))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.alwaysShowDescriptions))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.hideUndiscoveredItems))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.dynamicCursor))
             )
             .withComponent(new OptionsCategory("gui.options.page.general.category.miscellaneous")
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.discordRichPresence))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
index 2bc80ebd7..eaafc2209 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
@@ -179,7 +179,8 @@ public class GuiElementToastsHud extends Gui {
 
         GL11.glEnable(GL11.GL_DEPTH_TEST);
         ItemStack icon = toast.getIcon(duration);
-        ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, icon, x + 8, y + 8, 1.0f);
+//        ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, icon, x + 8, y + 8, 1.0f);
+        if (icon != null) ItemModelDispatcher.getInstance().getDispatch(icon).renderGui(Tessellator.instance, null, icon, x + 8, y + 8, 1f, 1f, 1.0f);
         GL11.glDisable(GL11.GL_DEPTH_TEST);
     }
 
